IsoEra (Java SE 26 & JDK 26)
Description: declaration: module: java.base, package: java.time.chrono, enum: IsoEra
Keywords: java.time.chrono.IsoEra class

# Enum Class IsoEra

java.lang.Object
java.lang.Enum<IsoEra>
java.time.chrono.IsoEra

All Implemented Interfaces:
  `Serializable, Comparable<IsoEra>, Constable, Era, TemporalAccessor, TemporalAdjuster`

public enum IsoEra extends Enum<IsoEra> implements Era
An era in the ISO calendar system.

The ISO-8601 standard does not define eras. A definition has therefore been created with two eras - 'Current era' (CE) for years on or after 0001-01-01 (ISO), and 'Before current era' (BCE) for years before that.

ISO years and eras
year-of-era | era | proleptic-year
--- | --- | ---
2 | CE | 2
1 | CE | 1
1 | BCE | 0
2 | BCE | -1

Do not use `ordinal()` to obtain the numeric representation of `IsoEra`. Use `getValue()` instead.

Implementation Requirements:
  This is an immutable and thread-safe enum.
Since:
  1.8

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class Enum

  `Enum.EnumDesc<E>`
  Modifier and Type
  Class
  Description
  `static final class`
  `Enum.EnumDesc<E extends Enum<E>>`
  A nominal descriptor for an `enum` constant.

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `BCE`
  The singleton instance for the era before the current one, 'Before Current Era', which has the numeric value 0.
  `CE`
  The singleton instance for the current era, 'Current Era', which has the numeric value 1.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `getValue()`
  Gets the numeric era `int` value.
  `static IsoEra`
  `of(int isoEra)`
  Obtains an instance of `IsoEra` from an `int` value.
  `static IsoEra`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static IsoEra[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
  Modifier and Type
  Method
  Description
  `protected final Object`
  `clone()`
  Throws CloneNotSupportedException.
  `final int`
  `compareTo(IsoEra o)`
  Compares this enum with the specified object for order.
  `final Optional<Enum.EnumDesc<IsoEra>>`
  `describeConstable()`
  Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
  `final boolean`
  `equals(Object other)`
  Returns true if the specified object is equal to this enum constant.
  `protected final void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization has been deprecated for removal.
  `final Class<IsoEra>`
  `getDeclaringClass()`
  Returns the Class object corresponding to this enum constant's enum type.
  `final int`
  `hashCode()`
  Returns a hash code for this enum constant.
  `final String`
  `name()`
  Returns the name of this enum constant, exactly as declared in its enum declaration.
  `final int`
  `ordinal()`
  Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
  `String`
  `toString()`
  Returns the name of this enum constant, as contained in the declaration.
  `static <T extends Enum<T>>
  T`
  `valueOf(Class<T> enumClass, String name)`
  Returns the enum constant of the specified enum class with the specified name.

  ### Methods declared in class Object

  `getClass, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

  ### Methods declared in interface Era

  `adjustInto, get, getDisplayName, getLong, isSupported, query, range`
  Modifier and Type
  Method
  Description
  `default Temporal`
  `adjustInto(Temporal temporal)`
  Adjusts the specified temporal object to have the same era as this object.
  `default int`
  `get(TemporalField field)`
  Gets the value of the specified field from this era as an `int`.
  `default String`
  `getDisplayName(TextStyle style, Locale locale)`
  Gets the textual representation of this era.
  `default long`
  `getLong(TemporalField field)`
  Gets the value of the specified field from this era as a `long`.
  `default boolean`
  `isSupported(TemporalField field)`
  Checks if the specified field is supported.
  `default <R> R`
  `query(TemporalQuery<R> query)`
  Queries this era using the specified query.
  `default ValueRange`
  `range(TemporalField field)`
  Gets the range of valid values for the specified field.

- ## Enum Constant Details

  - ### BCE

    public static final IsoEra BCE
    The singleton instance for the era before the current one, 'Before Current Era', which has the numeric value 0.

  - ### CE

    public static final IsoEra CE
    The singleton instance for the current era, 'Current Era', which has the numeric value 1.

- ## Method Details

  - ### values

    public static IsoEra[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static IsoEra valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### of

    public static IsoEra of(int isoEra)
    Obtains an instance of `IsoEra` from an `int` value.

    `IsoEra` is an enum representing the ISO eras of BCE/CE. This factory allows the enum to be obtained from the `int` value.

    Parameters:
      `isoEra` - the BCE/CE value to represent, from 0 (BCE) to 1 (CE)
    Returns:
      the era singleton, not null
    Throws:
      `DateTimeException` - if the value is invalid

  - ### getValue

    public int getValue()
    Gets the numeric era `int` value.

    The era BCE has the value 0, while the era CE has the value 1.

    Specified by:
      `getValue` in interface `Era`
    Returns:
      the era value, from 0 (BCE) to 1 (CE)